module Labyrinth
module QCutList
module CutList
  class BoardWarehouse
    def initialize(metricVolume)
      @boardList =BoardList.new
      @boardOptions = [[], [], [], false]
      @metricVolume = metricVolume
    end
    def boardOrder(length, width)
    end
    def boardReturn(board)
    end
  def getBoard
  end
  def boardsAvailable?
  end
  def widestBoardAvailable?
  end
  def thickestBoardAvailable?
  end
end
module RealBoards
  def getRealBoard(material, thickness)
    board = nil
    if (@availableSheets)
      _material = material.downcase
      sheetMatch = nil
      for itMaterialMatch in 0..1
        for itSizeMatch in 0..1
          for sheet in @availableSheets
            for materialMatch in sheet["mm"]
              materialMatch.downcase!
              if  _material.eql?(materialMatch) ||
                (itMaterialMatch == 1 && _material.include?(materialMatch))
                dif = (thickness - sheet['thickness'].to_f).abs
                if itSizeMatch == 0 && dif == 0
                  sheetMatch = sheet
                  break
                elsif itSizeMatch == 1 && dif < 0.124
                  sheetMatch = sheet
                  break
                end
                break
              else
              end # if material match
            end # for material
            if sheetMatch
              break
            end
          end # for sheet
          if sheetMatch
            break
          end
        end # for itSizeMatch
        if sheetMatch
          break
        end
      end # for itMaterialMatch
      if sheetMatch
        board = Board.new(
          (sheetMatch['length'] - (@edgeWaste * 2)).to_l,
          (sheetMatch['width'] - (@edgeWaste * 2)).to_l,
           sheetMatch['thickness'].to_l,
           material,
           @metricVolume,
          sheetMatch['sheetName']
        )
      end
    end
    return board
  end
  def getSpecificRealBoard(length, width, thickness, material)
  end
  def realBoardDelivery(boardList)
    @boardList = boardList
  end
  def anyRealBoardsAvailable?
    !@boardList.empty?
  end
  def widestRealBoardAvailable?
    return 0 if !anyRealBoardsAvailable?
    boardListArray = @boardList.getList
    widest = boardListArray[0].getWidth
    boardListArray.each { |board|
      width = board.getWidth;
      widest = width if width > widest
    }
    return widest
  end
  def thickestRealBoardAvailable?
    return 0 if !anyRealBoardsAvailable?
    boardListArray = @boardList.getList
    thickest = boardListArray[0].getThickness
    boardListArray.each { |board|
      thickness = board.getThickness;
      thickest = thickness if thickness > thickest
    }
    return thickest
  end
end
module VirtualBoards
  @@boardLimit = 100
  def getVirtualBoard(material, thickness)
    return nil if !anyVirtualBoardsAvailable?
    sortedLength = @boardOptions[0].sort
    sortedWidth = @boardOptions[1].sort
    longest = sortedLength.last
    widest = sortedWidth.last
    newThickness = closestThicknessVirtualBoard(thickness)
    if @nominalWidth
      board = Board.new(longest, widest, newThickness, material, @metricVolume)
    else
      board = NominalBoard.new(longest, widest, newThickness, material, @metricVolume)
    end
    @numberOfBoards -= 1
    return board
  end
  def getSpecificVirtualBoard(length, width, thickness, material)
    return nil if !anyVirtualBoardsAvailable?
    sortedLength = @boardOptions[0].sort
    sortedWidth = @boardOptions[1].sort
    closestLength = findClosest(length, sortedLength)
    closestWidth = findClosest(length, sortedWidth)
    return nil if (closestWidth == nil || closestLength == nil)
    if @nominalWidth
      board = Board.new(closestLength, closestWidth, thickness, material, @metricVolume)
    else
      board = NominalBoard.new(closestLength, closestWidth, thickness, material, @metricVolume)
    end
    @numberOfBoards -= 1
    return board
  end
  def findClosest(dimension, optionArray)
    largest = optionArray.select { |x| x >= dimension }
    return largest[0] if largest != nil
    smallest = optionArray.select { |x| x < dimension }
    return smallest[0] if smallest != nil
    return nil
  end
  def virtualBoardDelivery(boardOptions)
    @boardOptions = boardOptions
    @nominalWidth = boardOptions[3]
    @numberOfBoards = @@boardLimit
  end
  def anyVirtualBoardsAvailable?
    return false if @numberOfBoards == 0
    return (!@boardOptions[0].empty? && !@boardOptions[1].empty?)
  end
  def widestVirtualBoardAvailable?
    sortedWidth = @boardOptions[1].sort
    widestBoard = sortedWidth.last
    return widestBoard if @nominalWidth
    return widestBoard -= 1/2.inch if widestBoard <= 6.inch
    return widestBoard -= 3/4.inch
  end
  def thickestVirtualBoardAvailable?
    return (2.5).inch if @boardOptions[2][4]
    return 2.inch if @boardOptions[2][3]
    return (1.5).inch if @boardOptions[2][2]
    return (1.25).inch if @boardOptions[2][1]
    return 1.inch if @boardOptions[2][0]
    return 3/4.inch
  end
  def closestThicknessVirtualBoard(thickness)
    return 1.inch if @boardOptions[2][0] && 1.inch >= thickness
    return (1.25).inch if @boardOptions[2][1] && (1.25).inch >= thickness
    return (1.5).inch if @boardOptions[2][2] && (1.5).inch >= thickness
    return 2.inch if @boardOptions[2][3] && (2).inch >= thickness
    return (2.5).inch if @boardOptions[2][4] && (2.5).inch >= thickness
    return thickness
  end
end
class BoardLumberYard < BoardWarehouse
  include RealBoards
  def initialize(boardList, metricVolume)
    super(metricVolume)
    realBoardDelivery(boardList)
  end
  def getBoard(material="default", thickness=1.0.inch)
    getRealBoard(material, thickness)
  end
  def boardsAvailable?
    anyRealBoardsAvailable?
  end
  def widestBoardAvailable?
    widestRealBoardAvailable?
  end
  def thickestBoardAvailable?
    thickestRealBoardAvailable?
  end
end
class BoardServiceDesk < BoardWarehouse
  include VirtualBoards
  def initialize(boardOptions, metricVolume)
    super(metricVolume)
    virtualBoardDelivery(boardOptions)
  end
  def boardDelivery(boardList, boardOptions)
  end
  def getBoard(material="default", thickness=1.0.inch)
    getVirtualBoard(material, thickness)
  end
  def boardsAvailable?
    anyVirtualBoardsAvailable?
  end
  def widestBoardAvailable?
    widestVirtualBoardAvailable?
  end
  def thickestBoardAvailable?
    thickestVirtualBoardAvailable?
  end
end
class BoardSuperMarket < BoardWarehouse
  include RealBoards
  include VirtualBoards
  def initialize(boardList, boardOptions, metricVolume, availableSheets=nil, edgeWaste=0)
    super(metricVolume)
    @availableSheets = availableSheets
    @edgeWaste = edgeWaste
    realBoardDelivery(boardList)
    virtualBoardDelivery(boardOptions)
  end
  def getBoard(material="default", thickness=1.0.inch)
    board = getRealBoard(material, thickness)
    if !board
      board = getVirtualBoard(material, thickness);
    end
    return board
  end
  def boardsAvailable?
    return anyVirtualBoardsAvailable? if !anyRealBoardsAvailable?
    return true
  end
  def widestBoardAvailable?
    widestRealBoard = widestRealBoardAvailable?
    widestVirtualBoard = widestVirtualBoardAvailable?
    return widestRealBoard if widestRealBoard > widestVirtualBoard
    return widestVirtualBoard
  end
  def thickestBoardAvailable?
    thickestRealBoard = thickestRealBoardAvailable?
    thickestVirtualBoard = thickestVirtualBoardAvailable?
    return thickestRealBoard if thickestRealBoard > thickestVirtualBoard
    return thickestVirtualBoard
  end
end
class Board
  def initialize(length, width, thickness, material, metricVolume, sheetName=nil)
    @length = length.inch
    @width = width.inch
    @thickness = thickness.inch
    @material = material
    @sheetName = sheetName
    calcBoardFeet
    @length_px = CutList::float_round_to(0, ((@length/12)*100))
    @width_px = CutList::float_round_to(0, ((@width/12)*100))
    @area_px = @length_px*@width_px
    @metricVolume = metricVolume
  end
  def calcBoardFeet
    @area= @length*@width
    @boardFeet = (@area*@thickness)/144
  end
  def to_s
    getWidthString + ' x ' + getLengthString + ', ' + getThicknessString + ' ' + getMaterial + ' ' + getBoardFeetString
  end
  def getLength
    @length
  end
  def getLengthString
    getLength.to_l.to_s
  end
  def getWidth
    @width
  end
  def getWidthString
    getWidth.to_l.to_s
  end
  def getThickness
    @thickness
  end
  def getThicknessString
    getThickness.to_l.to_s
  end
  def getMaterial
    @material
  end
  def getLengthPx
    @length_px
  end
  def getWidthPx
    @width_px
  end
  def getAreaPx
    @area_px
  end
  def getSheetName
    @sheetName
  end
  def swapLengthWidth
    length = @length
    @length = @width
    @width = length
  end
  def getBoardFeet
    if @metricVolume
      CutList::float_round_to(4, @boardFeet*(2359.7372232207958956904236222001/1000000))
    else
      CutList::float_round_to(2, @boardFeet)
    end
  end
  def getRawBoardFeet
    @boardFeet
  end
  def getBoardFeetUnitsString
    return ' cu.m.' if @metricVolume
    return ' bd.ft.' if !@metricVolume
  end
  def getBoardFeetString
    string = CutList::decimal_to_comma(getBoardFeet.to_s)
    string += getBoardFeetUnitsString
    return string
  end
end
class NominalBoard < Board
  def initialize(length, width, thickness, material, metricVolume)
    @nominalWidth = width.inch
    if @nominalWidth <= 6.inch
      actualWidth = width.inch - 1/2.inch
    else
      actualWidth = width.inch - 3/4.inch
    end
    super(length, actualWidth, thickness, material, metricVolume)
  end
  def calcBoardFeet
    @area= @length*@nominalWidth
    @boardFeet = (@area*@thickness)/144
  end
  def getWidthString
    return getNominalWidth.to_l.to_s + "(" + getWidth.to_l.to_s + ")"
  end
  def getNominalWidth
    @nominalWidth
  end
end
class LayoutStatus
  def initialize(error, type)
    set(error, type)
  end
  def set(error, type)
    @error = error
    @type = type
  end
  def display
    if @type == "fatal"
      UI.beep
      UI.messagebox(@error)
    elsif @type == "error"
      UI.beep
      UI.messagebox(@error)
    elsif @type == "warning"
      UI.beep
      UI.messagebox(@error)
    elsif @type == "choice"
      UI.beep
      UI.messagebox(@error)
    elsif @type == "success"
    end
    @error=""
    @type="success"
  end
  def getResultType
    @type
  end
  def good?
    return true if (@type == "" || @type == "success")
    return false
  end
  def warn?
    return true if (@type == "warning" || @type == "choice")
    return false
  end
  def stop?
    return true if (@type == "error" || @type == "fatal")
    return false
  end
  def statusNotGood
    if good?
      return false
    end
    if warn?
      display
      return false
    end
    if stop?
      display
      return true
    end
    return false
  end
end
class LayoutBoard
  class LeafNode
    @@nodeType="leaf"
    def initialize(parent)
      @parent = parent
      @rect = {:xy => Array[0, 0], :length => 0, :width => 0}
    end
    def addRect(rect)
      @rect = @rect.merge!(rect)
    end
    def rect
      @rect
    end
    def getNodeType
      @@nodeType
    end
    def parent
      @parent
    end
  end # class LeafNode
  class Node
    @@nodeType="node"
    def initialize(parent)
      @parent = parent
      @left = nil
      @right = nil
      @part = {:xy => Array[0, 0], :length => 0, :width => 0}
    end
    def addLeft(rect)
      @left = LeafNode.new(self)
      @left.addRect(rect)
    end
    def addRight(rect)
      @right = LeafNode.new(self)
      @right.addRect(rect)
    end
    def left
      @left
    end
    def left=(left)
      @left=left
    end
    def right=(right)
      @right=right
    end
    def right
      @right
    end
    def parent
      @parent
    end
    def getNodeType
      @@nodeType
    end
    def part
      @part
    end
    def addPart(part)
      @part = @part.merge!(part)
    end
    def getPartArea
      return @part[:width]*@part[:length]
    end
  end #class Node
  def initialize(board, layoutOptions, metricVolume)
    @grainDir
    materialName = board.getMaterial
    if materialName
      materialInfo = Materials.getMaterial(materialName)
      @grainDir = materialInfo['grainDir']
    end
    if !@grainDir
      @grainDir = ''
    end
    @board = board
    @layoutOptions = layoutOptions
    if @layoutOptions[:layoutByLength]
      @board.swapLengthWidth
    end
    @partInBoardList = SolidPartList.new
    @kerfSize = @layoutOptions[:sawKerfSize] if @layoutOptions[:useSawKerf]
    @kerfSize = 0 if !@layoutOptions[:useSawKerf]
    @root = Node.new(self)
    topLeft = Array[0, 0]
    @root.addLeft({:xy => topLeft, :length => @board.getLength+@kerfSize, :width => @board.getWidth+@kerfSize})
    @boardFull = false
  end
  def addPartToBoard(layoutPart_)
    layoutPart = layoutPart_.clone
    if @layoutOptions[:layoutByLength]
      layoutPart.swapLengthWidth
    end
    leafNode = findBestFit(@root, layoutPart.getLength+@kerfSize, layoutPart.getWidth+@kerfSize)
    return false if leafNode == nil
    layoutPart.addLocationOnBoard(leafNode.rect[:xy])
    @partInBoardList.add(layoutPart)
    insertPartInTree(leafNode, {:xy => leafNode.rect[:xy], :length => layoutPart.getLength+@kerfSize, :width => layoutPart.getWidth+@kerfSize})
    return true
  end
  def insertPartInTree(leaf, layoutPart)
    leaf.parent.addPart(layoutPart)
    if leaf.parent != @root
      if leaf.parent.parent.left == leaf.parent
        leaf.parent.parent.right = nil
      else
        leaf.parent.parent.left = nil
      end
    end
    newParent = Node.new(leaf.parent)
    if leaf.parent.right == leaf
      leaf.parent.right = newParent
    else
      leaf.parent.left = newParent
    end
    newLeftChild = Node.new(newParent)
    newParent.left = newLeftChild
    newRightChild = Node.new(newParent)
    newParent.right = newRightChild
    newWidth = leaf.rect[:width] - layoutPart[:width]
    if newWidth != 0
      newx = leaf.rect[:xy][0]
      newy = leaf.rect[:xy][1]+layoutPart[:width]
      newLength = leaf.rect[:length]
      newOrigin = Array[newx, newy]
      newLeftChild.addLeft({:xy => newOrigin, :length => newLength, :width => newWidth})
    end
    newLength = leaf.rect[:length] - layoutPart[:length]
    if newLength != 0
      newy = leaf.rect[:xy][1]
      newx = leaf.rect[:xy][0]+layoutPart[:length]
      newWidth = layoutPart[:width]
      newOrigin = Array[newx, newy]
      newLeftChild.addRight({:xy => newOrigin, :length => newLength, :width => newWidth})
    end
    newWidth = leaf.rect[:width] - layoutPart[:width]
    if newWidth != 0
      newx = leaf.rect[:xy][0]
      newy = leaf.rect[:xy][1]+layoutPart[:width]
      newLength = layoutPart[:length]
      newOrigin = Array[newx, newy]
      newRightChild.addLeft({:xy => newOrigin, :length => newLength, :width => newWidth})
    end
    newLength = leaf.rect[:length] - layoutPart[:length]
    if newLength != 0
      newy = leaf.rect[:xy][1]
      newx = leaf.rect[:xy][0]+layoutPart[:length]
      newWidth = leaf.rect[:width]
      newOrigin = Array[newx, newy]
      newRightChild.addRight({:xy => newOrigin, :length => newLength, :width => newWidth})
    end
  end
  def findBestFit(node, length, width)
    return nil if node == nil
    leaf = false
    leaf = true if node.getNodeType == "leaf"
    if leaf
      return nil if length.to_l > node.rect[:length].to_l
      return nil if width.to_l > node.rect[:width].to_l
      return node
    end
    bestLeft = findBestFit(node.left, length, width)
    bestRight = findBestFit(node.right, length, width)
    return nil if bestLeft == nil && bestRight == nil
    return bestLeft if bestRight== nil
    return bestRight if bestLeft == nil
    area = length*width
    ruleA = (((bestLeft.rect[:length]*bestLeft.rect[:width]) - area) <= ((bestRight.rect[:length]*bestRight.rect[:width]) - area)) \
      && @layoutOptions[:layoutRuleA]
    ruleB = (bestLeft.rect[:xy][0] < bestRight.rect[:xy][0]) && @layoutOptions[:layoutRuleB]
    return bestLeft if ruleA || ruleB
    return bestRight
  end
  def getAreaOfParts(node)
    return 0 if node == nil
    return 0 if node.getNodeType == "leaf"
    areaLeft = getAreaOfParts(node.left)
    areaRight = getAreaOfParts(node.right)
    return (areaLeft + areaRight + node.getPartArea)
  end
  def areaOfPartsOnBoardFromList
    partInBoardListArray = @partInBoardList.getList
    totalArea = 0
    partInBoardListArray.each { |part|
      totalArea += part.getLengthPx*part.getWidthPx
    }
    return totalArea
  end
  def areaOfPartsOnBoard
    return getAreaOfParts(@root)
  end
  def getBoardPartList
    return @partInBoardList
  end
  def boardFull
    @boardFull
  end
  def setBoardFull
    @boardFull = true
    usedArea = areaOfPartsOnBoardFromList
    @usedAreaPercentage = CutList::float_round_to(2, ((usedArea/@board.getAreaPx)*100))
    if @layoutOptions[:layoutByLength]
      @board.swapLengthWidth
      parts = @partInBoardList.getList
      parts.each {|part|
        part.swapLengthWidth
      }
    end
  end
  def getUsedAreaPercentage
    @usedAreaPercentage
  end
  def board
    @board
  end
  def to_s
    return @board.to_s + (' (' + CutList::decimal_to_comma(getUsedAreaPercentage.to_s) + '%)' if getUsedAreaPercentage != 0)
  end
end #class LayourBoard
end # CutList
end # QCutList
end # Labyrinth
