module Labyrinth
module QCutList
module CutList
	        @@decimalNotation = ""
		def self.verbose1
			false # minimal progress tracking
		end
		def self.verbose
			false # the whole enchilada - slows down processing considerably - may crash sketchup - use sparingly. turn self.verbose on around desired areas
		end
		def self.verboseComponentDiscovery
			false # trace model entity list traversal only
		end
		def self.verbosePartPlacement
			true #trace parts placement for layout only
		end
		def self.verboseParameters
			false # trace parameter passing to/from the GUI
		end
		def self.metricModel?
		  model = Sketchup.active_model
		  unit = model.options["UnitsOptions"]["LengthUnit"]
		  return !(unit==0 || unit==1)
		end
		def self.modelInMeters?
		  model = Sketchup.active_model
		  unit = model.options["UnitsOptions"]["LengthUnit"]
		  return (unit==4)
		end
		def self.decimalSeparator
			'1.2'.to_l
			return '.'
		rescue
			return ','
		end	
		def self.initialiseDecimalNotation
			@@decimalNotation = self.decimalSeparator
		end
		def self.decimalNotationInitialised?
			@@decimalNotation != ""
		end
		def self.decimalNotation
			CutList::initialiseDecimalNotation if !CutList::decimalNotationInitialised? 
			@@decimalNotation
		end
		def self.float_round_to(x, float)
			(float * 10**x).round.to_f / 10**x
		end
		def self.integer_to_fws(width, integer)
		    val="%0#{width}d" % integer.to_s
		end
		def self.string_to_html(string)
		    val = string.gsub(/[&]/, "&amp;")  #do & first, so we don't convert the conversions!
		    val = val.gsub(/[ ]/, "&#32;")
		    val = val.gsub(/[']/, "&#39;")
		    val = val.gsub(/["]/, "&quot;")
		    val = val.gsub(/[<]/, "&lt;")
		    val = val.gsub(/[>]/, "&gt;")
		    val = val.gsub(/[-]/, "&#45;")
		    return val
		end 
		def self.string_to_clp(string)
		    val = string.gsub(/["]/,"\"\"")
		end
		def self.string_to_csv(string)
		     val = string.gsub(/[~]/,"")
		     pattern = /(\S*\s)*(\d+\/\d+)(\D*)$/
		     match = val.match pattern
		     if ( match && match[1] == nil && match[2] != nil )
			val="0 " + string
		     end
		     return val
		end
		def self.decimal_to_comma(string)
			pattern = /(\d+)(\.)(\d+)/
			match = string.match pattern
			if (match )
				val = string.gsub(/[.]/,"#{CutList::decimalNotation}")
				return val
			else
				return string
			end
		end
		def self.group_definition(group)
			if group.entities.parent.instances.include?(group)
				return group.entities.parent
			else
				Sketchup.active_model.definitions.each { |definition|
				return definition if definition.instances.include?(group)
				}
			end
		end
		def  self.version
			return "v4.1.12"
		end
		def self.year
			return "2014"
		end	
		def self.author
			return "S.Racz"
		end	
		def self.short_description
			return "Produce a materials list from your model and a layout" +
				  " of the parts on material of selectable sizes." 
		end	
end # CutList
end # QCutList
end # Labyrinth
